﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Xml.Linq;
using System.Windows.Markup;
using Infragistics.Controls.Menus;
using System.Windows.Media.Imaging;


namespace InfragisticOutlookBarWithTree
{
    public partial class MainPage : UserControl
    {

        OutlookBarGroup _obGroup;
        XamTree _xamTree;

        //const string PREFIX_STACKPANEL = "sp";
        const string PREFIX_TEXTBLOCK = "tb";
        const string PREFIX_BUTTON = "btn";
        //const string PREFIX_IMAGE = "img";
        const string STYLE_NAME = "DCDashButtonIcon";


        //Variable to refresh
        XamTreeItem _currentTreeItem;
        //OutlookBarGroup _currentOutlookBarGroup;
        string _CurrentKey = string.Empty;
        string[] BarGroupKey;
        //
        string outlookxml = "<NewDataSet><MenuTabs MenuTabID='6' MenuTabName='Dashboard Manager' MenuTabDisplayMessageCode='LMENU_TAB_006' UserRoleCode='' MenuTabIconName='DashboardManager'/><MenuTabs MenuTabID='7' MenuTabName='Report Manager' MenuTabDisplayMessageCode='LMENU_TAB_007' UserRoleCode='' MenuTabIconName='ReportManager'/><MenuTabs MenuTabID='8' MenuTabName='Dashboards' MenuTabDisplayMessageCode='LMENU_TAB_008' UserRoleCode='' MenuTabIconName='Dashboards'/><MenuTabs MenuTabID='9' MenuTabName='Reports' MenuTabDisplayMessageCode='LMENU_TAB_009' UserRoleCode='' MenuTabIconName='Reports'/><MenuItems MenuID='1' ScreenCode='EXTSYS_LIST' ParentMenuID='0' MenuDisplayMessageCode='LMENU_L0_001' MenuTabID='1' MenuName='External Systems' ControlName='ViewExternalSystems'/><MenuItems MenuID='2' ScreenCode='CONN_LIST#REALTIME_MODE' ParentMenuID='0' MenuDisplayMessageCode='LMENU_L0_002' MenuTabID='1' MenuName='Real Time Mode' ControlName='View.ViewConnections'/><MenuItems MenuID='3' ScreenCode='CONN_LIST#BATCH_MODE' ParentMenuID='0' MenuDisplayMessageCode='LMENU_L0_003' MenuTabID='1' MenuName='Batch Mode' ControlName='View.ViewConnections'/><MenuItems MenuID='4' ScreenCode='SCM_LIST' ParentMenuID='0' MenuDisplayMessageCode='LMENU_L0_004' MenuTabID='2' MenuName='Schemas' ControlName='SchemaDetails'/><MenuItems MenuID='5' ScreenCode='VIEW_SCD#ACQUISITION' ParentMenuID='0' MenuDisplayMessageCode='LMENU_L0_005' MenuTabID='3' MenuName='Data Acquisition Schedules' ControlName='ViewSchedulers'/><MenuItems MenuID='6' ScreenCode='VIEW_SCD#TRANSFER' ParentMenuID='0' MenuDisplayMessageCode='LMENU_L0_006' MenuTabID='3' MenuName='Data Transfer Schedules' ControlName='ViewSchedulers'/><MenuItems MenuID='7' ScreenCode='DSB_MST_TEMPLATE#TEMPLATE' ParentMenuID='0' MenuDisplayMessageCode='LMENU_L0_007' MenuTabID='6' MenuName='View Master Template' ControlName='View.Template'/><MenuItems MenuID='8' ScreenCode='DSB_MST_TEMPLATE#DESIGN' ParentMenuID='0' MenuDisplayMessageCode='LMENU_L0_008' MenuTabID='6' MenuName='Design Dashboards' ControlName='View.Template'/><MenuItems MenuID='9' ScreenCode='VIEW_DM' ParentMenuID='0' MenuDisplayMessageCode='LMENU_L0_009' MenuTabID='5' MenuName='DataModels' ControlName='ViewDataModels'/><MenuItems MenuID='10' ScreenCode='ADV_RPT_LIST' ParentMenuID='0' MenuDisplayMessageCode='LMENU_L0_0010' MenuTabID='7' MenuName='Advanced Reports' ControlName='View.Reports'/><MenuItems MenuID='11' ScreenCode='ADV_RPT_LIST#REPORTS' ParentMenuID='0' MenuDisplayMessageCode='LMENU_L0_0011' MenuTabID='9' MenuName='Reports' ControlName='View.EditRptParameters'/><MenuItems MenuID='12' ScreenCode='DIAGNOSTIC#BATCH_MODE_ACQUISITION' ParentMenuID='0' MenuDisplayMessageCode='LMENU_L0_0012' MenuTabID='4' MenuName='Acquisition Schedules' ControlName='View.DiagnosticBatchMode'/><MenuItems MenuID='13' ScreenCode='DIAGNOSTIC#REALTIME_MODE' ParentMenuID='0' MenuDisplayMessageCode='LMENU_L0_0013' MenuTabID='4' MenuName='Real Time Services' ControlName='View.DiagnosticRealTimeServices'/><MenuItems MenuID='2_Dashboard' ScreenCode='DSB_MST_TEMPLATE#DESIGN' ParentMenuID='8' MenuDisplayMessageCode='Design Dashboards' MenuTabID='6' FeatureCode='###' MenuName='DB 7 Control' ControlName='View.Template' /><MenuItems MenuID='3_Dashboard' ScreenCode='DSB_MST_TEMPLATE#DESIGN' ParentMenuID='8' MenuDisplayMessageCode='Design Dashboards' MenuTabID='6' FeatureCode='###' MenuName='Test' ControlName='View.Template' /> </NewDataSet>";

        public MainPage()
        {
            InitializeComponent();
        }


        private void LoadOutlookBar(string outlookbarXML)
        {
            XDocument doc = XDocument.Parse(outlookbarXML);
            var items = from item in doc.Descendants("MenuTabs")
                        select new MenuTabNode(item.Attribute("MenuTabID").Value, item.Attribute("MenuTabName").Value, item.Attribute("MenuTabIconName").Value, item.Attribute("MenuTabDisplayMessageCode").Value);
            //
            foreach (var i in items)
            {
                createOutlookBar(i.Key, i.Name, i.MenuTabIconName, i.MenuTabMessageCode, outlookbarXML);
            }
            //
            if (DCXamOutlookBar != null)
            {
                DCXamOutlookBar.AllowMinimized = true;
                DCXamOutlookBar.IsMinimized = false;
                DCXamOutlookBar.Width = 225;
            }
        }

        public void createOutlookBar(string key, string name, string menuTabIconName, string menuTabMessageCode, string outlookbarXML)
        {
            _obGroup = new OutlookBarGroup();
            _obGroup.Key = key;
            _obGroup.Name = name;
            _obGroup.Header = name; // name; //load string from resource file
            //
            if (name == "Data Connections")
                _obGroup.IsSelected = true;
            //
            string xamlString = @"<DataTemplate xmlns=""http://schemas.microsoft.com/client/2007""><Image Source=""/DecisionCenter.DashboardViewer;component/Images/" + menuTabIconName + @".png"" /></DataTemplate>"; //get the icon which will load icons as per the icon ID assign to menu
            DataTemplate template = XamlReader.Load(xamlString) as DataTemplate;
            //
            _obGroup.LargeIconTemplate = template;
            _obGroup.SmallIconTemplate = template;
            //
            _xamTree = new XamTree();
            _xamTree.Name = menuTabMessageCode;
            //
            XDocument xdoc = XDocument.Parse(outlookbarXML);
            //
            var items = from item in xdoc.Descendants("MenuItems")
                        where item.Attribute("MenuTabID").Value.Equals(key) && item.Attribute("ParentMenuID").Value.Equals("0")
                        select new MenuTreeNode(item.Attribute("MenuID").Value, item.Attribute("MenuName").Value, item.Attribute("MenuDisplayMessageCode").Value,
                            item.Attribute("ParentMenuID") == null ? "0" : item.Attribute("ParentMenuID").Value, item.Attribute("MenuTabID").Value, item.Attribute("ControlName").Value, item.Attribute("ScreenCode").Value);
            //
            foreach (var item in items)
            {
                XamTreeItem treeItem = new XamTreeItem();
                
                treeItem.Name = item.Id;
                treeItem.Tag = item.Id + ";" + item.Name + ";" + item.ControlName + ";" + item.NodeTag;
                //
                treeItem.HierarchicalItemTemplate = new Infragistics.Controls.HierarchicalDataTemplate();
                treeItem.HierarchicalItemTemplate.ItemTemplate = TreeDataTemplate(item.Name, "Information");
                treeItem.ItemTemplate = TreeDataTemplate(item.Name, "Information");

                treeItem.Header = AddStackpanel(item.Name, item.Id, item.MenuItemMessageCode, treeItem, key); // item.Name; //load string from resource file

                GetChildrens(xdoc, treeItem, item.Id, key);
                //
                _xamTree.Items.Add(treeItem);
            }
            //
            _obGroup.Content = _xamTree;
            //
            DCXamOutlookBar.Groups.Add(_obGroup);
            //        
        }

        private XamTreeItem GetChildrens(XDocument xdoc, XamTreeItem treeItem, string parentKey, string menuTabKey)
        {
            var items = from item in xdoc.Descendants("MenuItems")
                        where item.Attribute("ParentMenuID").Value.Equals(parentKey) && item.Attribute("MenuTabID").Value.Equals(menuTabKey)
                        select new MenuTreeNode(item.Attribute("MenuID").Value, item.Attribute("MenuName").Value, item.Attribute("MenuDisplayMessageCode").Value,
                            item.Attribute("ParentMenuID") == null ? "0" : item.Attribute("ParentMenuID").Value, item.Attribute("MenuTabID").Value, item.Attribute("ControlName").Value, item.Attribute("ScreenCode").Value);
            //
            foreach (var item in items)
            {
                XamTreeItem childItemNode = new XamTreeItem();
                //
                if (item.Id.ToString().Contains("_Dashboard") || item.Id.ToString().Contains("_DashView"))
                    childItemNode.Header = (item.Id.ToString().Contains("_Dashboard") ? item.Name : item.Name);  //item.Name; //load string from resource file
                else if (item.Id.ToString().Contains("_Report"))
                    childItemNode.Header = (item.Id.ToString().Contains("_Report") ? item.Name : item.Name);  //item.Name; //load string from resource file
                //
                childItemNode.Name = item.Id; //nodes.Id;
                childItemNode.Tag = item.Id + ";" + item.Name + ";" + item.ControlName + ";" + item.NodeTag + ";" + ((TextBlock)(((StackPanel)treeItem.Header).Children[0])).Text;
                //
                childItemNode.ItemTemplate = TreeDataTemplate(item.Name, "Information");
                //
                treeItem.Items.Add(childItemNode);
                //
                GetChildrens(xdoc, childItemNode, item.Id, menuTabKey);
                //
            }
            return treeItem;
        }

        private object AddStackpanel(string Message, string itemID, string menuItemMessageCode, XamTreeItem treeItem, string GroupBarkey)
        {
            StackPanel spMain = new StackPanel();
            //Getting button image
            Image img = new Image();
            //ImageSource imageSource;
            img.Source = new BitmapImage(new Uri(@"/InfragisticOutlookBarWithTree;component/Images/Refresh.png", UriKind.Relative));

            img.Margin = new Thickness(0, 0, 0, 0);
            img.HorizontalAlignment = HorizontalAlignment.Stretch;
            img.VerticalAlignment = VerticalAlignment.Stretch;
            img.Stretch = Stretch.UniformToFill;
            spMain.Orientation = Orientation.Horizontal;

            TextBlock tb = new TextBlock();
            tb.Name = PREFIX_TEXTBLOCK + itemID;
            tb.Text = Message;
            spMain.Children.Add(tb);

            //
            if (menuItemMessageCode == "LMENU_L0_0014" || menuItemMessageCode == "LMENU_L0_008" || menuItemMessageCode == "LMENU_L0_0011")
            {
                Button btnRefreshTreeItems = new Button();
                Thickness margin = new Thickness(5, 0, 0, 0);
                btnRefreshTreeItems.Name = PREFIX_BUTTON + itemID;
                btnRefreshTreeItems.BorderThickness = new Thickness(.2);
                btnRefreshTreeItems.Style = (Style)this.Resources[STYLE_NAME];
                btnRefreshTreeItems.Margin = margin;
                //
                SolidColorBrush b = new SolidColorBrush(Colors.Transparent);
                btnRefreshTreeItems.Background = b;
                btnRefreshTreeItems.BorderBrush = b;
                //
                StackPanel sp = new StackPanel();
                sp.Margin = new Thickness(0, 0, 0, 0);
                sp.Children.Add(img);


                btnRefreshTreeItems.Content = sp;
                btnRefreshTreeItems.Tag = treeItem;
                btnRefreshTreeItems.Click += new RoutedEventHandler(btnRefreshTreeItems_Click);
                spMain.Children.Add(btnRefreshTreeItems);
                spMain.Tag = GroupBarkey;
                
            }
            return spMain;
        }

        void btnRefreshTreeItems_Click(object sender, RoutedEventArgs e)
        {
            Button btn = (Button)sender;

            if (btn != null)
            {
                XamTreeItem treeItem = (XamTreeItem)btn.Tag;
                treeItem.Items.Clear();
                StackPanel parentStackPanel;
                if (btn.Parent != null)
                {
                    parentStackPanel = (StackPanel)btn.Parent;
                    if (parentStackPanel != null)
                    {
                        _CurrentKey = Convert.ToString(parentStackPanel.Tag);
                    }
                }
                //
                //BarGroupKey = treeItem.Tag.ToString().Split(';');
                //
                _currentTreeItem = treeItem;

                XDocument doc = XDocument.Parse(outlookxml);
                GetChildrens(doc, _currentTreeItem, _currentTreeItem.Name, _CurrentKey);
            }
        }

        private DataTemplate TreeDataTemplate(string MenuName, string IconName)
        {
            //
            string xamlTreeIconString = @"<DataTemplate xmlns=""http://schemas.microsoft.com/client/2007""><StackPanel Orientation=""Horizontal""><Image Source=""/DecisionCenter.DashboardViewer;component/Images/" + IconName + @".png"" Width=""16"" Height=""16"" /><TextBlock Text=" + "\"" + MenuName + "\"" + @" /></StackPanel></DataTemplate>"; //get the icon which will load icons as per the icon ID assign to menu
            DataTemplate treeTemplate = XamlReader.Load(xamlTreeIconString) as DataTemplate;
            //
            return treeTemplate;
        }

        private void LayoutRoot_Loaded(object sender, RoutedEventArgs e)
        {
            LoadOutlookBar(outlookxml);
        }
    }

    public class MenuTabNode
    {
        public string Name { get; set; }

        public string Key { get; set; }

        public string MenuTabIconName { get; set; }

        public string MenuTabMessageCode { get; set; }

        public MenuTabNode(string key, string name, string IconName, string MessageCode)
        {
            Key = key;
            Name = name;
            MenuTabIconName = IconName;
            MenuTabMessageCode = MessageCode;
        }
    }

    /// <summary>
    /// Use for tree menu items
    /// </summary>
    public class MenuTreeNode
    {
        public string Id { get; set; }

        public string Name { get; set; }

        public string MenuItemMessageCode { get; set; }

        public string AccessId { get; set; }

        public string ParentId { get; set; }

        public string ControlName { get; set; }

        public string NodeTag { get; set; }

        public MenuTreeNode(string id, string name, string menuItemMessageCode, string parent, string access, string controlName, string nodeTag)
        {
            Id = id;
            Name = name;
            MenuItemMessageCode = menuItemMessageCode;
            ParentId = parent;
            AccessId = access;
            ControlName = controlName;
            NodeTag = nodeTag;
        }

    }

    public class TopHeaderMenus
    {
        public bool UserRoleManagement { get; set; }
        public bool ApplicationSettings { get; set; }
        public bool DisplaySettings { get; set; }
        public bool UserRoleMaster { get; set; }
        public bool OnlineHelp { get; set; }

    }


    /// <summary>
    /// Currently not in use
    /// </summary>
    public class Information
    {
        public string ParentName { get; set; }

        public string ChildName { get; set; }

        public Information(string parent, string child)
        {
            ParentName = parent;
            ChildName = child;
        }

    }
}
